SystemOrganization addCategory: #'SBE-Quinto'!

SimpleSwitchMorph subclass: #SBECell
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Quinto'!

!SBECell commentStamp: 'ABO 12/31/2014 11:52' prior: 0!
Quinto cell!

!SBECell methodsFor: 'initialization' stamp: 'ABO 12/31/2014 11:56'!
initialize
	super initialize.
	self label: ''.
	self borderWidth: 2.
	bounds := 0@0 corner: 16@16.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff! !

!SBECell methodsFor: 'accessing' stamp: 'ABO 12/31/2014 15:08'!
mouseAction: aBlock
	^ mouseAction := aBlock! !

!SBECell methodsFor: 'as yet unclassified' stamp: 'ABO 12/31/2014 15:12'!
mouseUp: anEvent
	mouseAction value! !

BorderedMorph subclass: #SBEGame
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Quinto'!

!SBEGame commentStamp: 'ABO 12/31/2014 12:05' prior: 0!
Quinto game!

!SBEGame methodsFor: 'initialization' stamp: 'ABO 12/31/2014 12:21'!
cellsPerSide
	"The number of cells along each side of the game"
	^ 10! !

!SBEGame methodsFor: 'initialization' stamp: 'ABO 12/31/2014 12:16'!
initialize
	| sampleCell width height n |
	super initialize.
	n := self cellsPerSide.
	sampleCell := SBECell new.
	width := sampleCell width.
	height := sampleCell height.
	self
		bounds: (5 @ 5 extent: width * n @ (height * n) + (2 * self borderWidth)).
	cells := Matrix
				new: n
				tabulate: [:i :j | self newCellAt: i at: j]! !

!SBEGame methodsFor: 'initialization' stamp: 'ABO 12/31/2014 15:52'!
newCellAt: i at: j
	"Create a cell for position (i,j) and add it to my on-screen
	representation at the appropriate screen position.  Answer the new cell"
	| c origin |
	c := SBECell new.
	origin := self innerBounds origin.
	self addMorph: c.
	c position: ((i - 1) * c width) @ ((j - 1) * c height) + origin.
	c mouseAction: [self toggleNeighboursOfCellAt: i at: j].
	^ c! !

!SBEGame methodsFor: 'game logic' stamp: 'ABO 12/31/2014 15:04'!
toggleNeighboursOfCellAt: i at: j
	(i > 1) ifTrue: [ (cells at: i - 1 at: j ) toggleState].
	(i < self cellsPerSide) ifTrue: [ (cells at: i + 1 at: j) toggleState].
	(j > 1) ifTrue: [ (cells at: i at: j - 1) toggleState].
	(j < self cellsPerSide) ifTrue: [ (cells at: i at: j + 1) toggleState].! !
